#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use LWP 5.64;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "meta1") { &start; }
if ($q->param('fct') eq "get_meta") { &get_meta; }


sub start
{

$metpos = $q->param('metpos');
$url = $q->param('url');


print qq[
<html>
<head>
<title>Fetching...</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/admin72.cgi?fct=get_meta&url=$url&metpos=$metpos">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
<p align="center">Fetching <font color="#0000FF"><b>$url</b></font>...</p>
<p align="center"><img name="ani" src="$web_url/working2.gif"></p>
</body>
</html>
];

}



sub get_meta
{

$url = $q->param('url');
$metpos = $q->param('metpos');

my $browser = LWP::UserAgent->new;
$browser->agent("Mozilla/4.0 (compatible; MSIE 5.5)"); 
my $response = $browser->get($url);
$browser->timeout(15);

if ($response->is_success)
	{
	($Htitle, $Hmetakeyw, $Hmetadiz) = &parse_html($response->content);
	}
	else
	{
	$Htitle = "Connect Error: " . $response->status_line;
	}


$Htitle =~ s/'/\\'/g;
$Hmetadiz =~ s/'/\\'/g;
$Hmetakeyw =~ s/'/\\'/g;




print qq[<html>
<head>
<title>Fetching Meta Tags</title>

<script type="text/javascript">
<!-- Hide

function post_value(mpos)
{

if (mpos == 1)
	{
	titleval = opener.document.addform.title1.value;
	if (titleval.length < 1) { opener.document.addform.title1.value = '$Htitle'; }

	dizval = opener.document.addform.description1.value;
	if (dizval.length < 1) { opener.document.addform.description1.value = '$Hmetadiz'; }

	keywval = opener.document.addform.keywords1.value;
	if (keywval.length < 1) { opener.document.addform.keywords1.value = '$Hmetakeyw'; }
	}

if (mpos == 2)
	{
	titleval = opener.document.addform.title2.value;
	if (titleval.length < 1) { opener.document.addform.title2.value = '$Htitle'; }

	dizval = opener.document.addform.description2.value;
	if (dizval.length < 1) { opener.document.addform.description2.value = '$Hmetadiz'; }

	keywval = opener.document.addform.keywords2.value;
	if (keywval.length < 1) { opener.document.addform.keywords2.value = '$Hmetakeyw'; }
	}


if (mpos == 3)
	{
	titleval = opener.document.addform.title3.value;
	if (titleval.length < 1) { opener.document.addform.title3.value = '$Htitle'; }

	dizval = opener.document.addform.description3.value;
	if (dizval.length < 1) { opener.document.addform.description3.value = '$Hmetadiz'; }

	keywval = opener.document.addform.keywords3.value;
	if (keywval.length < 1) { opener.document.addform.keywords3.value = '$Hmetakeyw'; }
	}


if (mpos == 4)
	{
	titleval = opener.document.addform.title4.value;
	if (titleval.length < 1) { opener.document.addform.title4.value = '$Htitle'; }

	dizval = opener.document.addform.description4.value;
	if (dizval.length < 1) { opener.document.addform.description4.value = '$Hmetadiz'; }

	keywval = opener.document.addform.keywords4.value;
	if (keywval.length < 1) { opener.document.addform.keywords4.value = '$Hmetakeyw'; }
	}


if (mpos == 5)
	{
	titleval = opener.document.addform.title5.value;
	if (titleval.length < 1) { opener.document.addform.title5.value = '$Htitle'; }

	dizval = opener.document.addform.description5.value;
	if (dizval.length < 1) { opener.document.addform.description5.value = '$Hmetadiz'; }

	keywval = opener.document.addform.keywords5.value;
	if (keywval.length < 1) { opener.document.addform.keywords5.value = '$Hmetakeyw'; }
	}
window.close();


}

// End Hide -->
</script>

</head>
<body onload="post_value($metpos)">
</body>
</html>
];

}







sub parse_html
{

my ($pdata) = @_;
my ($begin_title, $end_title, $title, $ms, $begin_metad, $metadata, $end_metad, $metakeyw, $metadiz);

## TITLE
if ($pdata =~ m/<title>/gi)
	{
	$begin_title = pos($pdata);
	}

if ($pdata =~ m/<\/title>/gi)
	{
	$end_title = pos($pdata);
	$end_title = $end_title - 8;
	$end_title = $end_title - $begin_title;
	}

$title = substr($pdata, $begin_title, $end_title);

$pdata =~ m//gi;

### META TAG DESC/KEYW 1

for ($ms = 0; $ms < 10; $ms++)
{

$begin_metad = 0;

if ($pdata =~ m/<meta/gi)
	{
	$begin_metad = pos($pdata);

	$metadata = substr($pdata, $begin_metad, 400);
	
	$metadata =~ s/HTTP-EQUIV/name/gi;

	if ($metadata =~ m/>/gi)
		{
		$end_metad = pos($metadata);
		$metadata = substr($metadata, 0, $end_metad -1);
		}

	$metadata =~ s/Content="//gi;
	$metadata =~ s/Content = "//gi;
	$metadata =~ s/Content= "//gi;
	$metadata =~ s/Content ="//gi;
	$metadata =~ s/"//g;

	if (($metadata =~ /NAME=DESCRIPTION/i) or 
	   ($metadata =~ /NAME = DESCRIPTION/i) or 
	   ($metadata =~ /NAME =DESCRIPTION/i) or 
	   ($metadata =~ /NAME= DESCRIPTION/i))
		{
		$metadiz = $metadata;
		$metadiz =~ s/NAME=DESCRIPTION//gi;
		$metadiz =~ s/NAME = DESCRIPTION//gi;
		$metadiz =~ s/NAME= DESCRIPTION//gi;
		$metadiz =~ s/NAME =DESCRIPTION//gi;
		$metadiz =~ s/\n//g;
		}

	if (($metadata =~ /NAME=KEYWORDS/i) or 
	   ($metadata =~ /NAME = KEYWORDS/i) or 
	   ($metadata =~ /NAME =KEYWORDS/i) or 
	   ($metadata =~ /NAME= KEYWORDS/i))
		{
		$metakeyw = $metadata;
		$metakeyw =~ s/NAME=KEYWORDS//gi;
		$metakeyw =~ s/NAME = KEYWORDS//gi;
		$metakeyw =~ s/NAME= KEYWORDS//gi;
		$metakeyw =~ s/NAME =KEYWORDS//gi;
		$metakeyw =~ s/\n//g;
		}
	}

$pdata =~ s/<meta/<_m_e_t_a/i;

}

$crit1 = chr(10); 
$crit2 = chr(13); 

$title =~ s/$crit1//g; $title =~ s/$crit2//g;
$metakeyw =~ s/$crit1//g; $metakeyw =~ s/$crit2//g;
$metadiz =~ s/$crit1//g; $metadiz =~ s/$crit2//g;

if (substr($title, 0, 1) eq " ") { $title = substr($title, 1, length($title) - 1); }
if (substr($metakeyw, 0, 1) eq " ") { $metakeyw = substr($metakeyw, 1, length($metakeyw) - 1); }
if (substr($metadiz, 0, 1) eq " ") { $metadiz = substr($metadiz, 1, length($metadiz) - 1); }

if (substr($title, length($title) - 1, 1) eq "/") { $title = substr($title, 0, length($title) - 1); }
if (substr($metakeyw, length($metakeyw) - 1, 1) eq "/") { $metakeyw = substr($metakeyw, 0, length($metakeyw) - 1); }
if (substr($metadiz, length($metadiz) - 1, 1) eq "/") { $metadiz = substr($metadiz, 0, length($metadiz) - 1); }

return ($title, $metakeyw, $metadiz);

}









####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

